Bug 596900 - Position of changing lines needs improving in ja_JP.UTF-8
Position of changing lines needs improving in ja_JP.UTF-8
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: groff (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Jan Vcelak
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-05-27 14:16 EDT by Mamoru TASAKA
Modified: 2013-03-03 20:27 EST (History)
7 users (show)

See Also:
Fixed In Version: groff-1.20.1-3.fc15
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-11-26 06:26:20 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
screenshot of fprintf(3) with both man-db and man (63.72 KB, image/png)
2010-05-27 14:16 EDT, Mamoru TASAKA
no flags Details

  None (edit)
Description Mamoru TASAKA 2010-05-27 14:16:54 EDT
Created attachment 417335 [details]
screenshot of fprintf(3) with both man-db and man

Description of problem:
See screenshot:

With man-db, when trying to see Japanese man page fprintf(3)
if some long line exists such line is split on unexpected positions
and as the result fprintf(3) manual page cannot be seen easily
with man-db.

With man (in F-13) long lines are split on expected positions.

Version-Release number of selected component (if applicable):
man-db-2.5.7-2.fc14.i686

How reproducible:
100%

Steps to Reproduce:
1. install man-pages-ja
2. man fprintf in LANG=ja_JP.UTF-8
3.
  
Actual results:
See screenshot

Expected results:
New line should begin at expected positions like in F-13 man
Comment 1 Jan Vcelak 2010-05-31 07:06:32 EDT
Hi.

I will take it. Seems like a 'groff' problem.

Jan
Comment 2 Petr Pisar 2010-06-06 19:40:06 EDT
Proper word and line breaking rules are defined by JIS X 4051:2004 <http://www.webstore.jsa.or.jp/webstore/Com/FlowControl.jsp?lang=en&bunsyoId=JIS+X+4051%3A2004&dantaiCd=JIS&status=1&pageNo=0>. Wikipedia offers loose excerpt of some basic rules <http://en.wikipedia.org/wiki/Kinsoku_shori>. More complex overview provides <http://www.jepa.or.jp/press_release/reqEPUBJ.html> and <http://www.w3.org/TR/2009/NOTE-jlreq-20090604/>.

In addition to rules forbidding line break, groff must understand kana or kanji occupies two columns of fixed width terminal usually, whereas latin letters one column only. As man pages usually mix both of them, groff must compute proper width of each symbol precisely to get correct display width of a text.
Comment 3 Jan Vcelak 2010-07-30 05:40:08 EDT
Finally some update. I expect there will be some progress in upstream on this problem soon:

[Groff] character width in font files
http://www.mail-archive.com/groff@gnu.org/msg05443.html
Comment 4 Bug Zapper 2010-07-30 07:43:49 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 14 development cycle.
Changing version to '14'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Daiki Ueno 2010-08-05 21:54:29 EDT
Jan and Tasaka-san,

You might want to try a test package with the patches about which we are discussing with the upstream:

http://ueno.fedorapeople.org/groff/groff-1.20.1-3.fc13.src.rpm
Comment 6 Mamoru TASAKA 2010-08-06 15:35:59 EDT
(In reply to comment #5)
> Jan and Tasaka-san,
> 
> You might want to try a test package with the patches about which we are
> discussing with the upstream:
> 
> http://ueno.fedorapeople.org/groff/groff-1.20.1-3.fc13.src.rpm    

I tried this on F-14 and it seems good.
Comment 7 Jan Vcelak 2010-08-18 09:20:35 EDT
(In reply to comment #5)
> You might want to try a test package with the patches about which we are
> discussing with the upstream:

Thanks, it works well! However I don't want to include your patches now, as you qualified them as a "proof-of-concept". I definitely will not do it for F14. But I'm considering it into Rawhide.

Do you have some strong arguments?
Comment 8 Daiki Ueno 2010-08-23 23:46:09 EDT
I'd fine with it.  Thanks for testing.
Comment 9 Mamoru TASAKA 2010-08-27 13:14:36 EDT
I think this should be fixed in F-14, because for Japanese people
this issue is rather critical. Setting F14Target.
Comment 10 Jan Vcelak 2010-09-06 07:34:42 EDT
(In reply to comment #9)
> I think this should be fixed in F-14, because for Japanese people
> this issue is rather critical. Setting F14Target.

I completely understand you. But I don't want to put some code, which is not ready and verified, into stable release. This situation is really unpleasant.

Daiki, are you still working on your patches? Can we expect some progress soon? Do you think, your changes are safe enough to be included in F14 as they are?
Comment 11 Daiki Ueno 2010-09-06 21:39:55 EDT
(In reply to comment #9)
> I think this should be fixed in F-14, because for Japanese people
> this issue is rather critical. Setting F14Target.

Frankly I though that this was not that critical - Debian has the same issue since the last year and I have seen only a few people complaining :)

(In reply to comment #10)

> Daiki, are you still working on your patches? Can we expect some progress soon?
> Do you think, your changes are safe enough to be included in F14 as they are?

I'm now asking the original patch author about the status of his work but no response so far.

While it will take some time for the patch to be applied in upstream (because of paperwork, etc.), it might be worth asking them to check if the patch will not cause regression.  I'll do that anyway.
Comment 12 Jan Vcelak 2010-11-18 09:12:09 EST
Daiki, some news?
Comment 13 Daiki Ueno 2010-11-23 21:10:00 EST
Unfortunately, still no response from the upstream.

FWIW I updated the patches & SRPM to fix "TODO" lines in the original patch:
http://ueno.fedorapeople.org/groff/
(There are still a couple of TODOs left, which look harmless to me).

Perhaps it might be a good time to start testing in rawhide?
Comment 14 Jan Vcelak 2010-11-24 10:03:44 EST
I agree. The patch won't make things worse. :-) I will push that into Rawhide soon.

Daiki, please, could you poke people on groff list again? Send the updated patches with your comments and that we are going to try it in Fedora Rawhide? I would be very glad if we managed to get this included upstream.
Comment 15 Jan Vcelak 2010-11-26 06:26:20 EST
Fixed in groff-1.20.1-3.fc15

Daiki, thank you! Great work!
Comment 16 Colin Watson 2010-12-04 09:59:27 EST
I've left some comments on this patch in http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=552201 (also upstream, but their mailing list archive hasn't updated yet).  Folks on this bug may be interested.

Just to be explicit (although Jan implied it in comment 1), I expect that the appearance of this bug had everything to do with the switch from groff 1.18.1.4 with the old multibyte patch in Fedora 13 to groff 1.20.1 with no such patch in Fedora 14, and nothing to do with the switch from man to man-db that happened in the same release cycle.

Note You need to log in before you can comment on or make changes to this bug.